|
|
0a122b |
From df86b255911f2a682ffd411f4924442d6b007624 Mon Sep 17 00:00:00 2001
|
|
|
0a122b |
From: Kevin Wolf <kwolf@redhat.com>
|
|
|
0a122b |
Date: Tue, 14 Jan 2014 15:37:03 +0100
|
|
|
0a122b |
Subject: [PATCH 35/37] qemu-iotests: Test pwritev RMW logic
|
|
|
0a122b |
|
|
|
0a122b |
Message-id: <1392117622-28812-35-git-send-email-kwolf@redhat.com>
|
|
|
0a122b |
Patchwork-id: 57199
|
|
|
0a122b |
O-Subject: [RHEL-7.0 qemu-kvm PATCH v2 35/37] qemu-iotests: Test pwritev RMW logic
|
|
|
0a122b |
Bugzilla: 748906
|
|
|
0a122b |
RH-Acked-by: Laszlo Ersek <lersek@redhat.com>
|
|
|
0a122b |
RH-Acked-by: Stefan Hajnoczi <stefanha@redhat.com>
|
|
|
0a122b |
RH-Acked-by: Max Reitz <mreitz@redhat.com>
|
|
|
0a122b |
|
|
|
0a122b |
Signed-off-by: Kevin Wolf <kwolf@redhat.com>
|
|
|
0a122b |
Reviewed-by: Max Reitz <mreitz@redhat.com>
|
|
|
0a122b |
(cherry picked from commit 9e1cb96d9a5e434f389a4d7b7ff4dcdd71e8ec0f)
|
|
|
0a122b |
|
|
|
0a122b |
Conflicts:
|
|
|
0a122b |
block.c
|
|
|
0a122b |
block/blkdebug.c
|
|
|
0a122b |
include/block/block.h
|
|
|
0a122b |
tests/qemu-iotests/group
|
|
|
0a122b |
|
|
|
0a122b |
Conflicts because RHEL 7 doesn't have all blkdebug events that upstream
|
|
|
0a122b |
has. (Plus group from qemu-iotests.)
|
|
|
0a122b |
|
|
|
0a122b |
Signed-off-by: Kevin Wolf <kwolf@redhat.com>
|
|
|
0a122b |
---
|
|
|
0a122b |
block.c | 7 ++
|
|
|
0a122b |
block/blkdebug.c | 8 ++
|
|
|
0a122b |
include/block/block.h | 8 ++
|
|
|
0a122b |
tests/qemu-iotests/077 | 278 +++++++++++++++++++++++++++++++++++++++++++++
|
|
|
0a122b |
tests/qemu-iotests/077.out | 202 ++++++++++++++++++++++++++++++++
|
|
|
0a122b |
tests/qemu-iotests/group | 1 +
|
|
|
0a122b |
6 files changed, 504 insertions(+)
|
|
|
0a122b |
create mode 100755 tests/qemu-iotests/077
|
|
|
0a122b |
create mode 100644 tests/qemu-iotests/077.out
|
|
|
0a122b |
---
|
|
|
0a122b |
block.c | 7 +
|
|
|
0a122b |
block/blkdebug.c | 8 ++
|
|
|
0a122b |
include/block/block.h | 8 ++
|
|
|
0a122b |
tests/qemu-iotests/077 | 278 ++++++++++++++++++++++++++++++++++++++++++++
|
|
|
0a122b |
tests/qemu-iotests/077.out | 202 ++++++++++++++++++++++++++++++++
|
|
|
0a122b |
tests/qemu-iotests/group | 1 +
|
|
|
0a122b |
6 files changed, 504 insertions(+), 0 deletions(-)
|
|
|
0a122b |
create mode 100755 tests/qemu-iotests/077
|
|
|
0a122b |
create mode 100644 tests/qemu-iotests/077.out
|
|
|
0a122b |
|
|
|
0a122b |
diff --git a/block.c b/block.c
|
|
|
0a122b |
index d18c2df..d063924 100644
|
|
|
0a122b |
--- a/block.c
|
|
|
0a122b |
+++ b/block.c
|
|
|
0a122b |
@@ -2982,10 +2982,13 @@ static int coroutine_fn bdrv_aligned_pwritev(BlockDriverState *bs,
|
|
|
0a122b |
assert(!waited || !req->serialising);
|
|
|
0a122b |
|
|
|
0a122b |
if (flags & BDRV_REQ_ZERO_WRITE) {
|
|
|
0a122b |
+ BLKDBG_EVENT(bs, BLKDBG_PWRITEV_ZERO);
|
|
|
0a122b |
ret = bdrv_co_do_write_zeroes(bs, sector_num, nb_sectors, flags);
|
|
|
0a122b |
} else {
|
|
|
0a122b |
+ BLKDBG_EVENT(bs, BLKDBG_PWRITEV);
|
|
|
0a122b |
ret = drv->bdrv_co_writev(bs, sector_num, nb_sectors, qiov);
|
|
|
0a122b |
}
|
|
|
0a122b |
+ BLKDBG_EVENT(bs, BLKDBG_PWRITEV_DONE);
|
|
|
0a122b |
|
|
|
0a122b |
if (ret == 0 && !bs->enable_write_cache) {
|
|
|
0a122b |
ret = bdrv_co_flush(bs);
|
|
|
0a122b |
@@ -3058,11 +3061,13 @@ static int coroutine_fn bdrv_co_do_pwritev(BlockDriverState *bs,
|
|
|
0a122b |
};
|
|
|
0a122b |
qemu_iovec_init_external(&head_qiov, &head_iov, 1);
|
|
|
0a122b |
|
|
|
0a122b |
+ BLKDBG_EVENT(bs, BLKDBG_PWRITEV_RMW_HEAD);
|
|
|
0a122b |
ret = bdrv_aligned_preadv(bs, &req, offset & ~(align - 1), align,
|
|
|
0a122b |
align, &head_qiov, 0);
|
|
|
0a122b |
if (ret < 0) {
|
|
|
0a122b |
goto fail;
|
|
|
0a122b |
}
|
|
|
0a122b |
+ BLKDBG_EVENT(bs, BLKDBG_PWRITEV_RMW_AFTER_HEAD);
|
|
|
0a122b |
|
|
|
0a122b |
qemu_iovec_init(&local_qiov, qiov->niov + 2);
|
|
|
0a122b |
qemu_iovec_add(&local_qiov, head_buf, offset & (align - 1));
|
|
|
0a122b |
@@ -3090,11 +3095,13 @@ static int coroutine_fn bdrv_co_do_pwritev(BlockDriverState *bs,
|
|
|
0a122b |
};
|
|
|
0a122b |
qemu_iovec_init_external(&tail_qiov, &tail_iov, 1);
|
|
|
0a122b |
|
|
|
0a122b |
+ BLKDBG_EVENT(bs, BLKDBG_PWRITEV_RMW_TAIL);
|
|
|
0a122b |
ret = bdrv_aligned_preadv(bs, &req, (offset + bytes) & ~(align - 1), align,
|
|
|
0a122b |
align, &tail_qiov, 0);
|
|
|
0a122b |
if (ret < 0) {
|
|
|
0a122b |
goto fail;
|
|
|
0a122b |
}
|
|
|
0a122b |
+ BLKDBG_EVENT(bs, BLKDBG_PWRITEV_RMW_AFTER_TAIL);
|
|
|
0a122b |
|
|
|
0a122b |
if (!use_local_qiov) {
|
|
|
0a122b |
qemu_iovec_init(&local_qiov, qiov->niov + 1);
|
|
|
0a122b |
diff --git a/block/blkdebug.c b/block/blkdebug.c
|
|
|
0a122b |
index 1e772a5..c61ce52 100644
|
|
|
0a122b |
--- a/block/blkdebug.c
|
|
|
0a122b |
+++ b/block/blkdebug.c
|
|
|
0a122b |
@@ -183,6 +183,14 @@ static const char *event_names[BLKDBG_EVENT_MAX] = {
|
|
|
0a122b |
[BLKDBG_CLUSTER_ALLOC] = "cluster_alloc",
|
|
|
0a122b |
[BLKDBG_CLUSTER_ALLOC_BYTES] = "cluster_alloc_bytes",
|
|
|
0a122b |
[BLKDBG_CLUSTER_FREE] = "cluster_free",
|
|
|
0a122b |
+
|
|
|
0a122b |
+ [BLKDBG_PWRITEV_RMW_HEAD] = "pwritev_rmw.head",
|
|
|
0a122b |
+ [BLKDBG_PWRITEV_RMW_AFTER_HEAD] = "pwritev_rmw.after_head",
|
|
|
0a122b |
+ [BLKDBG_PWRITEV_RMW_TAIL] = "pwritev_rmw.tail",
|
|
|
0a122b |
+ [BLKDBG_PWRITEV_RMW_AFTER_TAIL] = "pwritev_rmw.after_tail",
|
|
|
0a122b |
+ [BLKDBG_PWRITEV] = "pwritev",
|
|
|
0a122b |
+ [BLKDBG_PWRITEV_ZERO] = "pwritev_zero",
|
|
|
0a122b |
+ [BLKDBG_PWRITEV_DONE] = "pwritev_done",
|
|
|
0a122b |
};
|
|
|
0a122b |
|
|
|
0a122b |
static int get_event_by_name(const char *name, BlkDebugEvent *event)
|
|
|
0a122b |
diff --git a/include/block/block.h b/include/block/block.h
|
|
|
0a122b |
index feb1926..13ef173 100644
|
|
|
0a122b |
--- a/include/block/block.h
|
|
|
0a122b |
+++ b/include/block/block.h
|
|
|
0a122b |
@@ -498,6 +498,14 @@ typedef enum {
|
|
|
0a122b |
BLKDBG_CLUSTER_ALLOC_BYTES,
|
|
|
0a122b |
BLKDBG_CLUSTER_FREE,
|
|
|
0a122b |
|
|
|
0a122b |
+ BLKDBG_PWRITEV_RMW_HEAD,
|
|
|
0a122b |
+ BLKDBG_PWRITEV_RMW_AFTER_HEAD,
|
|
|
0a122b |
+ BLKDBG_PWRITEV_RMW_TAIL,
|
|
|
0a122b |
+ BLKDBG_PWRITEV_RMW_AFTER_TAIL,
|
|
|
0a122b |
+ BLKDBG_PWRITEV,
|
|
|
0a122b |
+ BLKDBG_PWRITEV_ZERO,
|
|
|
0a122b |
+ BLKDBG_PWRITEV_DONE,
|
|
|
0a122b |
+
|
|
|
0a122b |
BLKDBG_EVENT_MAX,
|
|
|
0a122b |
} BlkDebugEvent;
|
|
|
0a122b |
|
|
|
0a122b |
diff --git a/tests/qemu-iotests/077 b/tests/qemu-iotests/077
|
|
|
0a122b |
new file mode 100755
|
|
|
0a122b |
index 0000000..bbf7b51
|
|
|
0a122b |
--- /dev/null
|
|
|
0a122b |
+++ b/tests/qemu-iotests/077
|
|
|
0a122b |
@@ -0,0 +1,278 @@
|
|
|
0a122b |
+#!/bin/bash
|
|
|
0a122b |
+#
|
|
|
0a122b |
+# Test concurrent pread/pwrite
|
|
|
0a122b |
+#
|
|
|
0a122b |
+# Copyright (C) 2014 Red Hat, Inc.
|
|
|
0a122b |
+#
|
|
|
0a122b |
+# This program is free software; you can redistribute it and/or modify
|
|
|
0a122b |
+# it under the terms of the GNU General Public License as published by
|
|
|
0a122b |
+# the Free Software Foundation; either version 2 of the License, or
|
|
|
0a122b |
+# (at your option) any later version.
|
|
|
0a122b |
+#
|
|
|
0a122b |
+# This program is distributed in the hope that it will be useful,
|
|
|
0a122b |
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
|
|
|
0a122b |
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
|
|
|
0a122b |
+# GNU General Public License for more details.
|
|
|
0a122b |
+#
|
|
|
0a122b |
+# You should have received a copy of the GNU General Public License
|
|
|
0a122b |
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
|
|
|
0a122b |
+#
|
|
|
0a122b |
+
|
|
|
0a122b |
+# creator
|
|
|
0a122b |
+owner=kwolf@redhat.com
|
|
|
0a122b |
+
|
|
|
0a122b |
+seq=`basename $0`
|
|
|
0a122b |
+echo "QA output created by $seq"
|
|
|
0a122b |
+
|
|
|
0a122b |
+here=`pwd`
|
|
|
0a122b |
+tmp=/tmp/$$
|
|
|
0a122b |
+status=1 # failure is the default!
|
|
|
0a122b |
+
|
|
|
0a122b |
+_cleanup()
|
|
|
0a122b |
+{
|
|
|
0a122b |
+ _cleanup_test_img
|
|
|
0a122b |
+}
|
|
|
0a122b |
+trap "_cleanup; exit \$status" 0 1 2 3 15
|
|
|
0a122b |
+
|
|
|
0a122b |
+# get standard environment, filters and checks
|
|
|
0a122b |
+. ./common.rc
|
|
|
0a122b |
+. ./common.filter
|
|
|
0a122b |
+
|
|
|
0a122b |
+_supported_fmt generic
|
|
|
0a122b |
+_supported_proto generic
|
|
|
0a122b |
+_supported_os Linux
|
|
|
0a122b |
+
|
|
|
0a122b |
+CLUSTER_SIZE=4k
|
|
|
0a122b |
+size=128M
|
|
|
0a122b |
+
|
|
|
0a122b |
+_make_test_img $size
|
|
|
0a122b |
+
|
|
|
0a122b |
+echo
|
|
|
0a122b |
+echo "== Some concurrent requests involving RMW =="
|
|
|
0a122b |
+
|
|
|
0a122b |
+function test_io()
|
|
|
0a122b |
+{
|
|
|
0a122b |
+echo "open -o file.align=4k blkdebug::$TEST_IMG"
|
|
|
0a122b |
+# A simple RMW request
|
|
|
0a122b |
+cat <
|
|
|
0a122b |
+aio_write -P 10 0x200 0x200
|
|
|
0a122b |
+aio_flush
|
|
|
0a122b |
+EOF
|
|
|
0a122b |
+
|
|
|
0a122b |
+# Sequential RMW requests on the same physical sector
|
|
|
0a122b |
+off=0x1000
|
|
|
0a122b |
+for ev in "head" "after_head" "tail" "after_tail"; do
|
|
|
0a122b |
+cat <
|
|
|
0a122b |
+break pwritev_rmw.$ev A
|
|
|
0a122b |
+aio_write -P 10 $((off + 0x200)) 0x200
|
|
|
0a122b |
+wait_break A
|
|
|
0a122b |
+aio_write -P 11 $((off + 0x400)) 0x200
|
|
|
0a122b |
+sleep 100
|
|
|
0a122b |
+resume A
|
|
|
0a122b |
+aio_flush
|
|
|
0a122b |
+EOF
|
|
|
0a122b |
+off=$((off + 0x1000))
|
|
|
0a122b |
+done
|
|
|
0a122b |
+
|
|
|
0a122b |
+# Chained dependencies
|
|
|
0a122b |
+cat <
|
|
|
0a122b |
+break pwritev_rmw.after_tail A
|
|
|
0a122b |
+aio_write -P 10 0x5000 0x200
|
|
|
0a122b |
+wait_break A
|
|
|
0a122b |
+aio_write -P 11 0x5200 0x200
|
|
|
0a122b |
+aio_write -P 12 0x5400 0x200
|
|
|
0a122b |
+aio_write -P 13 0x5600 0x200
|
|
|
0a122b |
+aio_write -P 14 0x5800 0x200
|
|
|
0a122b |
+aio_write -P 15 0x5a00 0x200
|
|
|
0a122b |
+aio_write -P 16 0x5c00 0x200
|
|
|
0a122b |
+aio_write -P 17 0x5e00 0x200
|
|
|
0a122b |
+sleep 100
|
|
|
0a122b |
+resume A
|
|
|
0a122b |
+aio_flush
|
|
|
0a122b |
+EOF
|
|
|
0a122b |
+
|
|
|
0a122b |
+# Overlapping multiple requests
|
|
|
0a122b |
+cat <
|
|
|
0a122b |
+break pwritev_rmw.after_tail A
|
|
|
0a122b |
+aio_write -P 10 0x6000 0x200
|
|
|
0a122b |
+wait_break A
|
|
|
0a122b |
+break pwritev_rmw.after_head B
|
|
|
0a122b |
+aio_write -P 10 0x7e00 0x200
|
|
|
0a122b |
+wait_break B
|
|
|
0a122b |
+aio_write -P 11 0x6800 0x1000
|
|
|
0a122b |
+resume A
|
|
|
0a122b |
+sleep 100
|
|
|
0a122b |
+resume B
|
|
|
0a122b |
+aio_flush
|
|
|
0a122b |
+EOF
|
|
|
0a122b |
+
|
|
|
0a122b |
+cat <
|
|
|
0a122b |
+break pwritev_rmw.after_tail A
|
|
|
0a122b |
+aio_write -P 10 0x8000 0x200
|
|
|
0a122b |
+wait_break A
|
|
|
0a122b |
+break pwritev_rmw.after_head B
|
|
|
0a122b |
+aio_write -P 10 0x9e00 0x200
|
|
|
0a122b |
+wait_break B
|
|
|
0a122b |
+aio_write -P 11 0x8800 0x1000
|
|
|
0a122b |
+resume B
|
|
|
0a122b |
+sleep 100
|
|
|
0a122b |
+resume A
|
|
|
0a122b |
+aio_flush
|
|
|
0a122b |
+EOF
|
|
|
0a122b |
+
|
|
|
0a122b |
+cat <
|
|
|
0a122b |
+break pwritev_rmw.after_tail A
|
|
|
0a122b |
+aio_write -P 10 0xa000 0x200
|
|
|
0a122b |
+wait_break A
|
|
|
0a122b |
+aio_write -P 11 0xa800 0x1000
|
|
|
0a122b |
+break pwritev_rmw.after_head B
|
|
|
0a122b |
+aio_write -P 10 0xbe00 0x200
|
|
|
0a122b |
+wait_break B
|
|
|
0a122b |
+resume A
|
|
|
0a122b |
+sleep 100
|
|
|
0a122b |
+resume B
|
|
|
0a122b |
+aio_flush
|
|
|
0a122b |
+EOF
|
|
|
0a122b |
+
|
|
|
0a122b |
+cat <
|
|
|
0a122b |
+break pwritev_rmw.after_tail A
|
|
|
0a122b |
+aio_write -P 10 0xc000 0x200
|
|
|
0a122b |
+wait_break A
|
|
|
0a122b |
+aio_write -P 11 0xc800 0x1000
|
|
|
0a122b |
+break pwritev_rmw.after_head B
|
|
|
0a122b |
+aio_write -P 10 0xde00 0x200
|
|
|
0a122b |
+wait_break B
|
|
|
0a122b |
+resume B
|
|
|
0a122b |
+sleep 100
|
|
|
0a122b |
+resume A
|
|
|
0a122b |
+aio_flush
|
|
|
0a122b |
+EOF
|
|
|
0a122b |
+
|
|
|
0a122b |
+# Only RMW for the tail part
|
|
|
0a122b |
+cat <
|
|
|
0a122b |
+break pwritev_rmw.after_tail A
|
|
|
0a122b |
+aio_write -P 10 0xe000 0x1800
|
|
|
0a122b |
+wait_break A
|
|
|
0a122b |
+aio_write -P 11 0xf000 0xc00
|
|
|
0a122b |
+sleep 100
|
|
|
0a122b |
+resume A
|
|
|
0a122b |
+aio_flush
|
|
|
0a122b |
+EOF
|
|
|
0a122b |
+
|
|
|
0a122b |
+cat <
|
|
|
0a122b |
+break pwritev A
|
|
|
0a122b |
+aio_write -P 10 0x10000 0x800
|
|
|
0a122b |
+wait_break A
|
|
|
0a122b |
+break pwritev_rmw.after_tail B
|
|
|
0a122b |
+aio_write -P 11 0x10000 0x400
|
|
|
0a122b |
+break pwritev_done C
|
|
|
0a122b |
+resume A
|
|
|
0a122b |
+wait_break C
|
|
|
0a122b |
+resume C
|
|
|
0a122b |
+sleep 100
|
|
|
0a122b |
+wait_break B
|
|
|
0a122b |
+resume B
|
|
|
0a122b |
+aio_flush
|
|
|
0a122b |
+EOF
|
|
|
0a122b |
+
|
|
|
0a122b |
+cat <
|
|
|
0a122b |
+break pwritev A
|
|
|
0a122b |
+aio_write -P 10 0x11000 0x800
|
|
|
0a122b |
+wait_break A
|
|
|
0a122b |
+aio_write -P 11 0x11000 0x1000
|
|
|
0a122b |
+sleep 100
|
|
|
0a122b |
+resume A
|
|
|
0a122b |
+aio_flush
|
|
|
0a122b |
+EOF
|
|
|
0a122b |
+}
|
|
|
0a122b |
+
|
|
|
0a122b |
+test_io | $QEMU_IO | _filter_qemu_io | \
|
|
|
0a122b |
+ sed -e 's,[0-9/]* bytes at offset [0-9]*,XXX/XXX bytes at offset XXX,g' \
|
|
|
0a122b |
+ -e 's/^[0-9]* \(bytes\|KiB\)/XXX bytes/' \
|
|
|
0a122b |
+ -e '/Suspended/d'
|
|
|
0a122b |
+
|
|
|
0a122b |
+echo
|
|
|
0a122b |
+echo "== Verify image content =="
|
|
|
0a122b |
+
|
|
|
0a122b |
+function verify_io()
|
|
|
0a122b |
+{
|
|
|
0a122b |
+ # A simple RMW request
|
|
|
0a122b |
+ echo read -P 0 0 0x200
|
|
|
0a122b |
+ echo read -P 10 0x200 0x200
|
|
|
0a122b |
+ echo read -P 0 0x400 0xc00
|
|
|
0a122b |
+
|
|
|
0a122b |
+ # Sequential RMW requests on the same physical sector
|
|
|
0a122b |
+ echo read -P 0 0x1000 0x200
|
|
|
0a122b |
+ echo read -P 10 0x1200 0x200
|
|
|
0a122b |
+ echo read -P 11 0x1400 0x200
|
|
|
0a122b |
+ echo read -P 0 0x1600 0xa00
|
|
|
0a122b |
+
|
|
|
0a122b |
+ echo read -P 0 0x2000 0x200
|
|
|
0a122b |
+ echo read -P 10 0x2200 0x200
|
|
|
0a122b |
+ echo read -P 11 0x2400 0x200
|
|
|
0a122b |
+ echo read -P 0 0x2600 0xa00
|
|
|
0a122b |
+
|
|
|
0a122b |
+ echo read -P 0 0x3000 0x200
|
|
|
0a122b |
+ echo read -P 10 0x3200 0x200
|
|
|
0a122b |
+ echo read -P 11 0x3400 0x200
|
|
|
0a122b |
+ echo read -P 0 0x3600 0xa00
|
|
|
0a122b |
+
|
|
|
0a122b |
+ echo read -P 0 0x4000 0x200
|
|
|
0a122b |
+ echo read -P 10 0x4200 0x200
|
|
|
0a122b |
+ echo read -P 11 0x4400 0x200
|
|
|
0a122b |
+ echo read -P 0 0x4600 0xa00
|
|
|
0a122b |
+
|
|
|
0a122b |
+ # Chained dependencies
|
|
|
0a122b |
+ echo read -P 10 0x5000 0x200
|
|
|
0a122b |
+ echo read -P 11 0x5200 0x200
|
|
|
0a122b |
+ echo read -P 12 0x5400 0x200
|
|
|
0a122b |
+ echo read -P 13 0x5600 0x200
|
|
|
0a122b |
+ echo read -P 14 0x5800 0x200
|
|
|
0a122b |
+ echo read -P 15 0x5a00 0x200
|
|
|
0a122b |
+ echo read -P 16 0x5c00 0x200
|
|
|
0a122b |
+ echo read -P 17 0x5e00 0x200
|
|
|
0a122b |
+
|
|
|
0a122b |
+ # Overlapping multiple requests
|
|
|
0a122b |
+ echo read -P 10 0x6000 0x200
|
|
|
0a122b |
+ echo read -P 0 0x6200 0x600
|
|
|
0a122b |
+ echo read -P 11 0x6800 0x1000
|
|
|
0a122b |
+ echo read -P 0 0x7800 0x600
|
|
|
0a122b |
+ echo read -P 10 0x7e00 0x200
|
|
|
0a122b |
+
|
|
|
0a122b |
+ echo read -P 10 0x8000 0x200
|
|
|
0a122b |
+ echo read -P 0 0x8200 0x600
|
|
|
0a122b |
+ echo read -P 11 0x8800 0x1000
|
|
|
0a122b |
+ echo read -P 0 0x9800 0x600
|
|
|
0a122b |
+ echo read -P 10 0x9e00 0x200
|
|
|
0a122b |
+
|
|
|
0a122b |
+ echo read -P 10 0xa000 0x200
|
|
|
0a122b |
+ echo read -P 0 0xa200 0x600
|
|
|
0a122b |
+ echo read -P 11 0xa800 0x1000
|
|
|
0a122b |
+ echo read -P 0 0xb800 0x600
|
|
|
0a122b |
+ echo read -P 10 0xbe00 0x200
|
|
|
0a122b |
+
|
|
|
0a122b |
+ echo read -P 10 0xc000 0x200
|
|
|
0a122b |
+ echo read -P 0 0xc200 0x600
|
|
|
0a122b |
+ echo read -P 11 0xc800 0x1000
|
|
|
0a122b |
+ echo read -P 0 0xd800 0x600
|
|
|
0a122b |
+ echo read -P 10 0xde00 0x200
|
|
|
0a122b |
+
|
|
|
0a122b |
+ # Only RMW for the tail part
|
|
|
0a122b |
+ echo read -P 10 0xe000 0x1000
|
|
|
0a122b |
+ echo read -P 11 0xf800 0x400
|
|
|
0a122b |
+ echo read -P 0 0xfc00 0x400
|
|
|
0a122b |
+
|
|
|
0a122b |
+ echo read -P 11 0x10000 0x400
|
|
|
0a122b |
+ echo read -P 10 0x10400 0x400
|
|
|
0a122b |
+
|
|
|
0a122b |
+ echo read -P 11 0x11800 0x800
|
|
|
0a122b |
+}
|
|
|
0a122b |
+
|
|
|
0a122b |
+verify_io | $QEMU_IO "$TEST_IMG" | _filter_qemu_io
|
|
|
0a122b |
+
|
|
|
0a122b |
+_check_test_img
|
|
|
0a122b |
+
|
|
|
0a122b |
+# success, all done
|
|
|
0a122b |
+echo "*** done"
|
|
|
0a122b |
+rm -f $seq.full
|
|
|
0a122b |
+status=0
|
|
|
0a122b |
diff --git a/tests/qemu-iotests/077.out b/tests/qemu-iotests/077.out
|
|
|
0a122b |
new file mode 100644
|
|
|
0a122b |
index 0000000..ab61234
|
|
|
0a122b |
--- /dev/null
|
|
|
0a122b |
+++ b/tests/qemu-iotests/077.out
|
|
|
0a122b |
@@ -0,0 +1,202 @@
|
|
|
0a122b |
+QA output created by 077
|
|
|
0a122b |
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=134217728
|
|
|
0a122b |
+
|
|
|
0a122b |
+== Some concurrent requests involving RMW ==
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'A'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'A'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'A'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'A'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'A'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'A'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'B'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'B'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'A'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'A'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'B'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'B'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'A'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'A'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'A'
|
|
|
0a122b |
+blkdebug: Resuming request 'C'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'B'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+blkdebug: Resuming request 'A'
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+wrote XXX/XXX bytes at offset XXX
|
|
|
0a122b |
+XXX bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+
|
|
|
0a122b |
+== Verify image content ==
|
|
|
0a122b |
+read 512/512 bytes at offset 0
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 512
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 3072/3072 bytes at offset 1024
|
|
|
0a122b |
+3 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 4096
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 4608
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 5120
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 2560/2560 bytes at offset 5632
|
|
|
0a122b |
+2.500 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 8192
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 8704
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 9216
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 2560/2560 bytes at offset 9728
|
|
|
0a122b |
+2.500 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 12288
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 12800
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 13312
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 2560/2560 bytes at offset 13824
|
|
|
0a122b |
+2.500 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 16384
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 16896
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 17408
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 2560/2560 bytes at offset 17920
|
|
|
0a122b |
+2.500 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 20480
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 20992
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 21504
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 22016
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 22528
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 23040
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 23552
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 24064
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 24576
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 1536/1536 bytes at offset 25088
|
|
|
0a122b |
+1.500 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 4096/4096 bytes at offset 26624
|
|
|
0a122b |
+4 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 1536/1536 bytes at offset 30720
|
|
|
0a122b |
+1.500 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 32256
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 32768
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 1536/1536 bytes at offset 33280
|
|
|
0a122b |
+1.500 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 4096/4096 bytes at offset 34816
|
|
|
0a122b |
+4 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 1536/1536 bytes at offset 38912
|
|
|
0a122b |
+1.500 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 40448
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 40960
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 1536/1536 bytes at offset 41472
|
|
|
0a122b |
+1.500 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 4096/4096 bytes at offset 43008
|
|
|
0a122b |
+4 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 1536/1536 bytes at offset 47104
|
|
|
0a122b |
+1.500 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 48640
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 49152
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 1536/1536 bytes at offset 49664
|
|
|
0a122b |
+1.500 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 4096/4096 bytes at offset 51200
|
|
|
0a122b |
+4 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 1536/1536 bytes at offset 55296
|
|
|
0a122b |
+1.500 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 512/512 bytes at offset 56832
|
|
|
0a122b |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 4096/4096 bytes at offset 57344
|
|
|
0a122b |
+4 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 1024/1024 bytes at offset 63488
|
|
|
0a122b |
+1 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 1024/1024 bytes at offset 64512
|
|
|
0a122b |
+1 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 1024/1024 bytes at offset 65536
|
|
|
0a122b |
+1 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 1024/1024 bytes at offset 66560
|
|
|
0a122b |
+1 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+read 2048/2048 bytes at offset 71680
|
|
|
0a122b |
+2 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
0a122b |
+No errors were found on the image.
|
|
|
0a122b |
+*** done
|
|
|
0a122b |
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
|
|
|
0a122b |
index 50a726e..dd70acb 100644
|
|
|
0a122b |
--- a/tests/qemu-iotests/group
|
|
|
0a122b |
+++ b/tests/qemu-iotests/group
|
|
|
0a122b |
@@ -71,3 +71,4 @@
|
|
|
0a122b |
067 rw auto
|
|
|
0a122b |
068 rw auto
|
|
|
0a122b |
070 rw auto
|
|
|
0a122b |
+077 rw auto
|
|
|
0a122b |
--
|
|
|
0a122b |
1.7.1
|
|
|
0a122b |
|